package jp.co.ecosysnetwork.ccloca_app;

import android.app.Application;
import android.content.Context;
import android.media.MediaPlayer;
import android.os.Environment;

import java.util.Locale;

import jp.co.ecosysnetwork.ccloca_app.models.drive_state;
import jp.co.ecosysnetwork.universal.EsnDebugLog;

/**
 * 自身のアプリケーションクラス
 */
public class MyApplication extends Application {
    //region ディレクトリ
    /**
     * ログファイルディレクトリ
     */
    public static final String LOG_DIRECTORY = "/Log/";
    // endregion
    //region プリファレンス
    /**
     * プリファレンスの名称
     */
    public static final String PREFERENCE_NAME = "ccloca_app_prf";
    /**
     * プリファレンスキー名称（ログファイル最終送信日）
     */
    public static final String PKEY_LOG_LAST_SEND_DATE = "LogLastSendDate";
    /**
     * プリファレンスキー名称（サーバURL）
     */
    public static final String PKEY_SERVER_URL = "ServerUrl";
    /**
     * プリファレンスキー名称（更新間隔）
     */
    public static final String PKEY_UPDATE_CYCLE_MSEC = "UpdateCycleMsec";
    /**
     * プリファレンスキー名称（接近判定）
     */
    public static final String PKEY_APPROACH_JUDGE_METER = "ApproachJudgeMeter";
    /**
     * プリファレンスキー名称（形態端末ＩＤ）
     */
    public static final String PKEY_PHONE_ID = "PhoneId";
    /**
     * プリファレンスキー名称（運行設定されているコースのinfo_wkey。 %d：運行順インデックス）
     */
    public static final String PKEY_COURSE_SETTINGS_KEY = "CourseSettingsKey_%d";
    /**
     * プリファレンスキー名称（コース情報の個数）
     */
    public static final String PKEY_COURSE_INFO_NUM = "CourseInfoNum";
    /**
     * プリファレンスキー名称（コース情報＞コースの表示順。 %d：コースインデックス）
     */
    public static final String PKEY_COURSE_INFO_DISP_ORDER = "CourseInfoDispOrder_%d";
    /**
     * プリファレンスキー名称（コース情報＞コースキー。 %d：コースインデックス）
     */
    public static final String PKEY_COURSE_INFO_INFO_WKEY = "CourseInfoInfoWkey_%d";
    /**
     * プリファレンスキー名称（コース情報＞コース名。 %d：コースインデックス）
     */
    public static final String PKEY_COURSE_INFO_INFO_WNAME = "CourseInfoInfoWname_%d";
    /**
     * プリファレンスキー名称（コース情報＞通過ポイントの個数。 %d：コースインデックス）
     */
    public static final String PKEY_COURSE_INFO_POINT_NUM = "CourseInfoPointNum_%d";
    /**
     * プリファレンスキー名称（コース情報＞通過ポイントの順番。 %d：コースインデックス %d：通過ポイントインデックス）
     */
    public static final String PKEY_COURSE_INFO_POINT_STEP = "CourseInfoPoint_%d_Step_%d";
    /**
     * プリファレンスキー名称（コース情報＞通過ポイントのキー。 %d：コースインデックス %d：通過ポイントインデックス）
     */
    public static final String PKEY_COURSE_INFO_POINT_INFO_MKEY = "CourseInfoPoint_%d_InfoMkey_%d";
    /**
     * プリファレンスキー名称（コース情報＞通過ポイントの名称。 %d：コースインデックス %d：通過ポイントインデックス）
     */
    public static final String PKEY_COURSE_INFO_POINT_INFO_MNAME = "CourseInfoPoint_%d_InfoMname_%d";
    /**
     * プリファレンスキー名称（コース情報＞通過ポイントの緯度。 %d：コースインデックス %d：通過ポイントインデックス）
     */
    public static final String PKEY_COURSE_INFO_POINT_INFO_MLAT = "CourseInfoPoint_%d_InfoMlat_%d";
    /**
     * プリファレンスキー名称（コース情報＞通過ポイントの経度。 %d：コースインデックス %d：通過ポイントインデックス）
     */
    public static final String PKEY_COURSE_INFO_POINT_INFO_MLON = "CourseInfoPoint_%d_InfoMlon_%d";
    /**
     * プリファレンスキー名称（コース情報＞通過ポイントのメール送信有無。 %d：コースインデックス %d：通過ポイントインデックス）
     */
    public static final String PKEY_COURSE_INFO_POINT_INFO_ML = "CourseInfoPoint_%d_InfoMl_%d";
    /**
     * プリファレンスキー名称（最終運転日）
     */
    public static final String PKEYlast_update_course_date = "last_drive_date";
    /**
     * プリファレンスキー名称（現在のコースインデックス）
     */
    public static final String PKEY_NOW_COURSE_INDEX = "now_course_index";
    /**
     * プリファレンスキー名称（運行状態）
     */
    public static final String PKEY_OPERATION_STATE = "operation_state";
    /**
     * プリファレンスキー名称（接近情報リスト）
     */
    public static final String PKEY_POINT_APPROACHS = "point_approachs";
    /**
     * プリファレンスキー名称（コース情報＞コースのID。 %d：コースインデックス）
     */
    public static final String PKEY_BUS_ROUTE_INFO_ID = "BusRouteInfoID_%d";
    /**
     * プリファレンスキー名称（コース情報＞コース名称。 %d：コースインデックス）
     */
    public static final String PKEY_BUS_ROUTE_INFO_NAME = "BusRouteInfoName_%d";
    /**
     * リファレンスキー名称（選択中コースID）
     *
     */
    public static final String PKEY_SELECTED_BUS_ROUTE_INFO_ID = "SelectedBusRouteInfoID";
    /**
     * プリファレンスキー名称（選択中コース名称）
     */
    public static final String PKEY_SELECTED_BUS_ROUTE_INFO_NAME = "SelectedBusRouteInfoName";
    /**
     * プリファレンスキーポジション（選択中コースポジション）
     */
    public static final String PKEY_SELECTED_BUS_ROUTE_INFO_POSITION = "SelectedBusRouteInfoPosition";
    // endregion
    //region パスワード
    /**
     * コース設定のパスワード
     */
    private static final String PASSWORD_COURSE_SETTINGS = "12345";
    /**
     * システム設定のパスワード
     */
    private static final String PASSWORD_SYSTEM_SETTINGS = "ecosys";
    // endregion
    //region APIのURL
    /**
     * コース情報取得API
     */
    public static final String APIURL_GET_COURSE = "/getBusRouteListFromPhoneNo";
    /**
     * メール送信API
     */
    public static final String APIURL_GET_SEND_MAIL  = "/system/_locate.php?id=%s&ml=%s&mc=%d&wkey=%s&fg=%d";
    /**
     * 位置情報送信API
     */
    public static final String APIURL_GET_SEND_POS = "/system/_locate.php?id=%s&la=%.9f&ln=%.10f&al=%.10f&dy=%s&tm=%s&ag=%d&ck=&ac=%d&st=%d&fg=%d&wkey=%s";
    /**
     * 携帯端末チェックAPI
     */
    public static final String APIURL_CHECK_PHONE_ID = "/checkPhoneId";
    /**
     * 運行開始API
     */
    public static final String APIURL_START_BUS_COURSE = "/startBusCourse";
    /**
     * 運行終了API
     */
    public static final String APIURL_END_BUS_COURSE = "/endBusCourse";
    /**
     * 運行中位置情報送信API
     */
    public static final String APIURL_SEND_BUS_LOCATION = "/sendDeliveryNotification";
    //endregion
    //region ApiKey
    /**
     *  サーバにAPIを送る際のKey
     */
    public static final String API_KEY = "AIY4KPTHfnEcdyd8Rkii8RRmQYEaCYz7c8KTexc";
    //endregion

    //region メンバ変数
    /**
     * シングルトン
     */
    private static MyApplication _instance = null;
    /**
     * 運転状態モデル
     */
    public drive_state drive_state_model;
    // endregion
    //region 外部公開メンバ変数（getInstance()メソッドを通してアクセスすること）
    // endregion
    //region イベント
    /**
     * アプリケーション作成時のイベント
     * Application#onCreateは、ActivityやServiceが生成される前に呼ばれる。
     */
    @Override
    public void onCreate() {
        super.onCreate();
        _instance = this;
        drive_state_model = new drive_state(_instance.getApplicationContext().getSharedPreferences(PREFERENCE_NAME, Context.MODE_PRIVATE));
    }
    // endregion
    //region プロパティ
    /**
     * アプリケーションのインスタンスを返す
     *
     * @return アプリケーションのインスタンス
     */
    public static MyApplication getInstance() {
        return _instance;
    }
    // endregion
    //region 外部公開メソッド
    /**
     * ログ出力ディレクトリの取得
     * @return ログ出力ディレクトリ
     */
    public String getLogDirectory() {
        return _instance.getExternalFilesDir(Environment.DIRECTORY_DOCUMENTS) + LOG_DIRECTORY;
    }
    /**
     * コース設定パスワードが一致するかの判定
     * @param inpPass 入力パスワード
     * @return true：一致 false：不一致
     */
    public boolean isOkCourseSettingPassword(String inpPass) {
        return PASSWORD_COURSE_SETTINGS.equals(inpPass);
    }
    /**
     * システム設定パスワードが一致するかの判定
     * @param inpPass 入力パスワード
     * @return true：一致 false：不一致
     */
    public boolean isOkSystemSettingPassword(String inpPass) {
        return PASSWORD_SYSTEM_SETTINGS.equals(inpPass);
    }
    /**
     * スリープ
     * @param msec スリープ時間
     */
    public static void sleep(long msec){
        try {
            Thread.sleep(msec);
        } catch (InterruptedException e) {
            EsnDebugLog.outputLog(String.format(Locale.JAPAN, "例外エラー %s", e.toString()), EsnDebugLog.DIV.ERR);
        }
    }
    /**
     * WAVファイルの再生
     * @param resId wavファイルのリソースID
     * @param playTimeMsec wavファイルの再生時間
     */
    public void playWav(int resId, long playTimeMsec){
        MediaPlayer mp = MediaPlayer.create(this, resId);
        mp.start();
        sleep(playTimeMsec);
        mp.release();
    }
    //endregion
}
